/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package worlds3dclient;

/**
 *
 * @author Eduardo Seiti de Oliveira - RA 940011
 */

import java.awt.*;
import java.awt.event.*;
import java.util.Locale;

import javax.swing.BoxLayout;


public class World3D_client extends Frame {

    private static final String VERSION = "1.2";
    
    private List enteredCommands;
    
    protected static TextArea commandResponses;
    
    static {
        commandResponses = new TextArea();
    };
    
    //TextField txtField;
    
    private UserCommandsListener commandsListener = null;
    private BoxLayout mainLayout = null;

    private CommandProcessor commandProcessor = null;
      
    public class UserCommandsListener extends KeyAdapter {
        
        private CommandProcessor commandProcessor;
        
        public UserCommandsListener(CommandProcessor whichProcessor) {
            super();
            
            commandProcessor = whichProcessor;
        }
                
        
        public void keyPressed(KeyEvent e) {
            int commandCode = e.getKeyCode();
            String commandText = e.getKeyText(commandCode);
            
            String str = "Pressed: " + commandText + " = " + String.valueOf(commandCode) + "\n";
            
            enteredCommands.add(str);
            enteredCommands.makeVisible(enteredCommands.getItemCount() - 1);
            
            commandProcessor.process(commandCode);
        }

        public void keyReleased(KeyEvent e) {
            int code = e.getKeyCode();
            
            String str = "Released: " + e.getKeyText(code) + " = " + String.valueOf(code) + "\n";
            
            enteredCommands.add(str);
            enteredCommands.makeVisible(enteredCommands.getItemCount() - 1);
        }
    }

    

    
    public World3D_client() {
        super("World3D client");
        
        mainLayout = new BoxLayout(this, BoxLayout.PAGE_AXIS);
        
        setLayout(mainLayout);
        
        
                
        enteredCommands = new List();
        
        
        commandResponses.setEditable(false);
        
     
             
        
        add(enteredCommands);
        add(commandResponses);

        
        
        
        commandProcessor = CommandProcessor.getInstance();
        
        commandsListener = new UserCommandsListener(commandProcessor);

        enteredCommands.addKeyListener(commandsListener);
        
        //commandProcessor.process(ServerSender.CREATE_CREATURE);

        
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent we) {
                
                System.exit(0);
            }
        });
        
        setSize(700, 400);
        setVisible(true);        
        
        
        // Print initial help information
        
        commandResponses.append("--- World3D client * Version: " + VERSION + "---\n\n"
                              + "Eduardo Seiti de Oliveira - RA 940011 - IA006B\n\n"
                              + "F1         - Envia comando \"showworldthings\"\n"
                              + "F2         - Cria uma nova criatura na posio 100, 100\n"
                              + "Left/Right - Rotaciona criatura em ngulos de 45\n"
                              + "Up/Down    - Aumenta/Diminui velocidade linear da criatura\n"
                              + "Space      - Para a criatura\n"
                              + "R          - Recarrega o combustvel da criatura\n"
                              + "Escape     - Finaliza programa.\n\n");
    }

    
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        World3D_client k = new World3D_client();

    }
}
